diff --git a/sys/dev/vt/vt_core.c b/sys/dev/vt/vt_core.c
index 39b9265..d85d5e8 100644
--- a/sys/dev/vt/vt_core.c
+++ b/sys/dev/vt/vt_core.c
@@ -145,6 +145,7 @@ static int vt_late_window_switch(struct vt_window *);
 static int vt_proc_alive(struct vt_window *);
 static void vt_resize(struct vt_device *);
 static void vt_update_static(void *);
+static void vt_upgrade_static(void *);
 
 SET_DECLARE(vt_drv_set, struct vt_driver);
 
@@ -203,23 +204,28 @@ DATA_SET(cons_set, vt_consterm_consdev);
  * Right after kmem is done to allow early drivers to use locking and allocate
  * memory.
  */
-SYSINIT(vt_update_static, SI_SUB_KMEM, SI_ORDER_ANY, vt_update_static,
-    &vt_consdev);
+SYSINIT(vt_init_1, SI_SUB_KMEM, SI_ORDER_ANY, vt_update_static, NULL);
 /* Delay until all devices attached, to not waste time. */
-SYSINIT(vt_early_cons, SI_SUB_INT_CONFIG_HOOKS, SI_ORDER_ANY, vt_upgrade,
-    &vt_consdev);
+SYSINIT(vt_init_2, SI_SUB_INT_CONFIG_HOOKS, SI_ORDER_ANY, vt_upgrade_static, NULL);
 
 /* Initialize locks/mem depended members. */
 static void
 vt_update_static(void *dummy)
 {
+	if (main_vd == NULL)
+		return;
+	printf("VT: running with driver \"%s\".\n",
+	    main_vd->vd_driver->vd_name);
+	mtx_init(&main_vd->vd_lock, "vtdev", NULL, MTX_DEF);
+	cv_init(&main_vd->vd_winswitch, "vtwswt");
+}
 
-	if (main_vd != NULL) {
-		printf("VT: running with driver \"%s\".\n",
-		    main_vd->vd_driver->vd_name);
-		mtx_init(&main_vd->vd_lock, "vtdev", NULL, MTX_DEF);
-		cv_init(&main_vd->vd_winswitch, "vtwswt");
-	}
+static void
+vt_upgrade_static(void *dummy)
+{
+	if (main_vd == NULL)
+		return;
+	vt_upgrade(main_vd);
 }
 
 static void
